class "matrix" {
	__settings=
	{
		new=
		function(a,b,...)
			if type(a)=="number" and type(b)=="number" then
				local newmatrix={}
				local defaultval={...}
				defaultval=defaultval[1]
				for y=1,b do
					newmatrix[y]={}
					for x=1,a do
						newmatrix[y][x]=defaultval
					end
				end
				return {matrix=newmatrix}
			else
				local mat={}
				if not b then
					if type(a[1])=="table" then
						mat=a
					else
						mat={a}
					end
				else
					mat={a,b,...}
				end
				return {matrix=mat}
			end
		end,
		mt=
		{
			__call=
			function(self,x,y,v)
				if self.matrix[y] and self.matrix[y][x] then
					local val=self.matrix[y][x]
					if v then
						self.matrix[y][x]=v
					end
					return val
				end
			end,

			__tostring=
			function(self)
				local prevy=1
				local str="Matrix:\n"
				for x,y,v in self.points() do
					local attach=", "
					if x==1 and y==1 then attach="" end
					if y>prevy then
						prevy=y
						attach="\n"
					end
					str=str..attach..tostring(v)
				end
				return str
			end
		}
	},

	points=
	function()
		local posY,posX=1,0
		return function()
			posX=posX+1
			if not self(posX,posY) then
				posY=posY+1
				if self.matrix[posY] then
					posX=1
				else
					return nil
				end
			end
			return posX,posY,self(posX,posY)
		end
	end
}