require "lib.cereal"
require "lib.wOOP"
require "classes.matrix"
require "classes.shape"

function love.load()
	score=0
	shapes={"L","J","O","Z","S"} -- I is disabled, just add it back in to see.
	sh=shape(randomShape())
	rot=1
	x=6
	y=0
	updatetick=1
	world=matrix(
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,0,0,0,0,0,0,0,0,0,0,0,0,-1},
		{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}
	)
end

--check for things

function posCollidesWithPart(_x,_y)
	local collides={}
	for yp,row in pairs(sh.getShape()) do
		for xp,val in pairs(row) do
			local v=world(x+xp,y+yp)
			if v and val then
				collides[#collides+1]={x+xp,y+yp,v}
			end
		end
	end
	for i,v in pairs(collides) do
		if v[1]==_x and v[2]==_y then
			return v[3]
		end
	end
end

function checkForLose()
	local r=world.matrix[1]
	for i,v in pairs(r) do if not tonumber(v) then error("You lose! Final score : "..score) end end
end

function checkForRowWin()
	local wins={}
	for y,row in pairs(world.matrix) do
		if y==#world.matrix then break end
		local rowwin=true
		for i,v in pairs(row) do
			print(i,y,v)
			if v==0 then
				rowwin=false
				break
			end
		end
		if rowwin then
			wins[#wins+1]=y
		end
	end
	table.sort(wins)
	for i,v in pairs(wins) do
		for yp=v,1,-1 do
			world.matrix[yp]=(world.matrix[yp-1] or getBlankRow())
		end
		score=score+1
	end
	checkForLose()
end

--draw

function love.draw()
	drawworld()
	love.graphics.setColor(0,255,0)
	sh.draw(x*16-16,y*16-16)
	love.graphics.print("Score : "..score,15*16,0)
end

function drawworld()
	for xp,yp,v in world.points() do
		if not posCollidesWithPart(xp,yp) then
			love.graphics.setColor(getColorFor(v))
			love.graphics.print(tonumber(v) and "|" or "d",xp*16-16,yp*16-16)
		end
	end
end

--other

function getBlankRow()
	return {-1,0,0,0,0,0,0,0,0,0,0,0,0,-1}
end

function addPartToWorld()
	for yp,row in pairs(sh.getShape()) do
		for xp,val in pairs(row) do
			if val then
				world(x+xp,y+yp,sh.shape)
			end
		end
	end
	checkForRowWin()
end

function getColorFor(v)
	colors=colors or {}
	if v==-1 then
		return 255,0,0
	elseif v==0 then
		return 255,255,255
	elseif colors[v] then
		return colors[v]
	else
		colors[v]=shape(v).color
		return colors[v]
	end
end

function randomShape()
	return shapes[math.random(1,#shapes)]
end

--event callbacks

function love.keypressed(k)
	if not love.keyboard.isDown(" ") then
		local dir=0
		if k=="right" then
			dir=1
		elseif k=="left" then
			dir=-1
		elseif k=="down" then
			updatetick=0.125
		end
		x=x+dir
		for yp,row in pairs(sh.getShape()) do
			for xp,val in pairs(row) do
				if val then
					if posCollidesWithPart(x+xp,y+yp) and posCollidesWithPart(x+xp,y+yp)~=0 then
						x=x-dir
					end
				end
			end
		end
	else
		if k=="right" then
			sh.rot=sh.rot+1
			if sh.rot>4 then sh.rot=1 end
		elseif k=="left" then
			sh.rot=sh.rot-1
			if sh.rot<1 then sh.rot=4 end
		end
		local dir=0
		if x>6 then dir=1 else dir=-1 end
		for yp,row in pairs(sh.getShape()) do
			for xp,val in pairs(row) do
				if val then
					if posCollidesWithPart(x+xp,y+yp) and posCollidesWithPart(x+xp,y+yp)~=0 then
						x=x-dir
					end
				end
			end
		end
	end
end

function love.keyreleased(k)
	if k=="down" then
		updatetick=1
	end
end

function love.update(dt)
	cycle=(cycle or 0)+dt
	if cycle>=updatetick then
		cycle=cycle-updatetick
		y=y+1
		if y==#world.matrix then --phases through every once in a while? this is the "fix".
			y=y-2
		end
		for yp, row in pairs(sh.getShape()) do
			for xp, val in pairs(sh.getShape()) do
				if val then
					if posCollidesWithPart(x+xp,y+yp+1) and posCollidesWithPart(x+xp,y+yp+1)~=0 then
						y=y-1
						addPartToWorld()
						sh=shape(randomShape())
						x,y=6,0
					end
				end
			end
		end
	end
end